/* ************************************************************************** */
/*                                       _____           _                    */
/*  main.h                              |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: p7os                       | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/09/28 06:00:10                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#ifndef MAIN_H
# define MAIN_H
# include <stdio.h>
# include <libp7.h>
# define Q(x) #x
# define QUOTE(x) Q(x)
# define log(S, ...) fprintf(stderr, S, ##__VA_ARGS__)

/* ************************************************************************** */
/*  Embedded update.exe                                                       */
/* ************************************************************************** */
#define update_exe_str (_binary_update_exe_bin_start)
#define update_exe_end (_binary_update_exe_bin_end)
extern char _binary_update_exe_bin_start[];
extern char _binary_update_exe_bin_end[];

/* ************************************************************************** */
/*  CLI options                                                               */
/* ************************************************************************** */
/* Menu */
typedef enum {
	mn_prepare,
	mn_get
} menu_t;

/* Arguments */
typedef struct {
	/* basic things */
	menu_t menu;

	/* others */
	char *device;
	FILE *local; const char *localpath;
} args_t;

/* Parsing function */
int parse_args(int ac, char **av, args_t *args);

/* ************************************************************************** */
/*  Actual things                                                             */
/* ************************************************************************** */
/* Main functions */
int get_os(p7_handle_t *handle, FILE *dest);

#endif /* MAIN_H */
